/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by GJ Business Division RICOH COMPANY,LTD. JAPAN  
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2009 by GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.c 1.0 2009-09-27 10:03:00 roi $
 */

/*
 *  ꥢI/OǥХSIO:BULE-TOOTH˥ɥ饤СMINDSTORMS-NXTѡ
 */

#include <kernel.h>
#include <t_syslog.h>
#include "at91sam7s.h"
#include "mindstormsnxt.h"
#include "target_syssvc.h"
#include "target_serial.h"

#define	TADR_US1_BASE   (TADR_US_BASE+US_WINDOW)
#define TADR_TC1_BASE   (TADR_TC_BASE+TC_WINDOW)
#define TADR_TC2_BASE   (TADR_TC_BASE+TC_WINDOW*2)

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block 
{
    void* uart_base;
    void* time_base;
}
SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block 
{
    const SIOPINIB  *p_siopinib;  /* ꥢI/OݡȽ֥å */
    intptr_t  exinf;              /* ĥ */
    bool_t    openflag;           /* ץѤߥե饰 */
	bool_t    intflag;            /* ߾ */
	int_t     connect_state;      /* BLUETOOTH ³ */
	uint16_t  rcv_idx;            /* 󥿥ǥå */
	uint8_t   rcv_no;             /* Хåեǥå */
    uint8_t   snd_stat[3];        /* Хåեơ */
	int16_t   bcount;             /* Хåեǡ */
	int16_t   obcount;            /* ҤȤ bcount */
	uint8_t   rcv_buf[2][SIORBUFSIZE];	/* Хåե */
	SIOPACKET snd_buf[NUM_SNDBUF];	/* Хåե */
};

#define siobuffer       snd_buf[0].buf

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
    {(void*)(TADR_US1_BASE), (void*)(TADR_TC2_BASE) }
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

#define get_us1_rcvcnt1()   sil_rew_mem((void*)(TADR_US1_BASE+TOFF_PDC_RCR))
#define get_us1_rcvcnt2()   sil_rew_mem((void*)(TADR_US1_BASE+TOFF_PDC_RNCR))
#define set_us1_rcvcnt2(a)  sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_RNCR), a)
#define set_us1_rcvptr2(a)  sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_RNPR), a)


#define BT_RX_PIN        AT91S_PIO_PA21
#define BT_TX_PIN        AT91S_PIO_PA22
#define BT_SCK_PIN       AT91S_PIO_PA23
#define BT_RTS_PIN       AT91S_PIO_PA24
#define BT_CTS_PIN       AT91S_PIO_PA25
#define BT_CS_PIN        AT91S_PIO_PA31
#define BT_RST_PIN       AT91S_PIO_PA11
#define BT_ARM7_CMD_PIN  AT91S_PIO_PA27


#define MSG_RESET_INDICATION 20


#define BAUD_RATE 460800

/*
 * ʸ?
 */ 
Inline bool_t
uart_getready(SIOPCB *p_siopcb)
{
	int     bytes_ready;

	if(get_us1_rcvcnt2() == 0)
		bytes_ready = SIORBUFSIZE*2 - get_us1_rcvcnt1();
	else
		bytes_ready = SIORBUFSIZE - get_us1_rcvcnt1();
	return bytes_ready - p_siopcb->rcv_idx;
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
uart_putready(SIOPCB *p_siopcb)
{
	return (sil_rew_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_PDC_TNCR)) == 0
				&& sil_rew_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_PDC_TCR)) == 0);
}

/*
 *  ʸν񤭹
 */
Inline void
uart_puts(SIOPCB *p_siopcb, uint8_t *buf, int16_t len)
{
	/*
	 *  DMAȥˡǡΥɥ쥹ȥΤ餻
	 */
	sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_PDC_TNPR), (unsigned long)buf);
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_PDC_TNCR), len);
}


/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_IER), US_TXBUFE);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *p_siopcb)
{
	sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_IDR), US_TXBUFE);
}


/*
 *  ߵ
 *  BLUETOOTHѼDMAˤŬڤʼߤʤ
 *  TC2Υޤˤ10MSΥݡ󥰤Ԥ
 *  TC2γߵ
 */
Inline void
uart_enable_rcv(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->time_base+TOFF_TC_IER), TC_CPCS);
}

/*
 *  ߶ػ
 *  BLUETOOTHѼDMAˤŬڤʼߤʤ
 *  TC2Υޤˤ10MSΥݡ󥰤Ԥ
 *  TC2γ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->time_base+TOFF_TC_IDR), TC_CPCS);
}

/*
 *  IDΰζѥåֹ֤
 */
static int_t
bluetooth_search_packet(SIOPCB *p_siopcb, uint_t id)
{
	int_t no;

	if(p_siopcb->snd_stat[id] == 0)
		return -1;
	for(no = 0 ; no < 8 ; no++){
		if(p_siopcb->snd_stat[id] & (1<<no))
			return no;
	}
	return -1;
}

/*
 *  ԤѥåȤ
 */
static void
bluetooth_tx_int(SIOPCB *p_siopcb)
{
	SIOPACKET *p;
	int_t     no;

	p_siopcb->snd_stat[SND_EMPY] |= p_siopcb->snd_stat[SND_OUT];
	p_siopcb->snd_stat[SND_OUT] = 0;
	if((no = bluetooth_search_packet(p_siopcb, SND_RDY)) >= 0){
		p_siopcb->snd_stat[SND_OUT] |= 1<<no;
		p_siopcb->snd_stat[SND_RDY] &= ~(1<<no);
		p = &p_siopcb->snd_buf[no];
		uart_puts(p_siopcb, p->buf, p->len);
	}
	else{
		uart_disable_send(p_siopcb);
	}
}

/*
 *  BLUETOOTHޥζѥåȤξ֤֤
 */
ER_BOOL
bluetooth_send_ready(ID portid)
{
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);		/* ݡֹΥå */
	}
	return(get_siopcb(portid)->snd_stat[SND_EMPY] != 0);
}

/*
 *  BLUETOOTHΥޥɼԤǡ֤
 */
ER_UINT
bluetooth_received_count(ID portid)
{
    SIOPCB  *siopcb;

	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);		/* ݡֹΥå */
	}
	siopcb = get_siopcb(portid);
	return uart_getready(siopcb);
}

void
bluetooth_clear_arm7_cmd(void)
{
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_CODR), BT_ARM7_CMD_PIN);
}

void
bluetooth_set_arm7_cmd(void)
{
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_SODR), BT_ARM7_CMD_PIN);
}

/*
 *  BLUETOOTHѤΥޥѶѥåȤ֤
 */
ER
bluetooth_get_packet(ID portid, SIOPACKET **ppkt, int_t *plen)
{
    SIOPCB *p_siopcb;
	int_t  no;

	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);		/* ݡֹΥå */
	}
	p_siopcb = get_siopcb(portid);
	if((no = bluetooth_search_packet(p_siopcb, SND_EMPY)) >= 0){
		p_siopcb->snd_stat[SND_EMPY] &= ~(1<<no);
		*ppkt = &p_siopcb->snd_buf[no];
		*plen = SIORBUFSIZE;
		return E_OK;
	}
	else{
		*plen = 0;
		return E_NOMEM;
	}
}

/*
 *  BLUETOOTHΥޥѥåȤ׵᤹
 */
ER
bluetooth_send(ID portid, SIOPACKET *p)
{
    SIOPCB  *p_siopcb;

	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);		/* ݡֹΥå */
	}
	p_siopcb = get_siopcb(portid);
	if(uart_putready(p_siopcb)){
		p_siopcb->snd_stat[SND_RDY] |= 1<<p->id;
		uart_enable_send(p_siopcb);
	}
	return E_OK;
}

/*
 *  BLUETOOTHޥɤФ
 */
ER
bluetooth_receive(ID portid, unsigned char * buf)
{
    SIOPCB   *p_siopcb;
	int bytes_ready, total_bytes_ready;
	int cmd_len = 0;
	int i;
	unsigned char *buf_ptr, *tmp_ptr;

	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);		/* ݡֹΥå */
	}
	p_siopcb = get_siopcb(portid);
	buf_ptr = &(p_siopcb->rcv_buf[p_siopcb->rcv_no&1][0]);
	buf[0] = 0;
	buf[1] = 0;

	if (get_us1_rcvcnt2() == 0){
	  	bytes_ready = SIORBUFSIZE;
	  	total_bytes_ready = SIORBUFSIZE*2 - get_us1_rcvcnt1();
	}
	else{
		total_bytes_ready = bytes_ready = SIORBUFSIZE - get_us1_rcvcnt1();
	}
	/*
	 *  2ХȰʾμǡ
	 *  ޥɤμߤԤ
	 */
	if (total_bytes_ready > p_siopcb->rcv_idx + 1) {
	  	cmd_len = (int) buf_ptr[p_siopcb->rcv_idx];
  	
	  	// Data mode kludge - data cannot be more than 255 bytes
  	
		if (p_siopcb->rcv_idx < (SIORBUFSIZE-1)){
	  		if (buf_ptr[p_siopcb->rcv_idx+1] == 0) cmd_len++;
		}
		else{
			tmp_ptr = &(p_siopcb->rcv_buf[(p_siopcb->rcv_no+1)&1][0]);
			if (tmp_ptr[0] == 0) cmd_len++;
		}
		/*
		 *  ޥɤμߤԤ
		 */
		if (bytes_ready >= p_siopcb->rcv_idx + cmd_len + 1) {
			for(i=0;i<cmd_len+1;i++) buf[i] = buf_ptr[p_siopcb->rcv_idx++];
		}
		else if (total_bytes_ready >= p_siopcb->rcv_idx + cmd_len + 1){
			for(i=0;i<cmd_len+1 && p_siopcb->rcv_idx < 128;i++) buf[i] = buf_ptr[p_siopcb->rcv_idx++];
			p_siopcb->rcv_idx = 0;
			tmp_ptr = &(p_siopcb->rcv_buf[(p_siopcb->rcv_no+1)&1][0]);
			for(;i<cmd_len+1;i++) buf[i] = tmp_ptr[p_siopcb->rcv_idx++];
			p_siopcb->rcv_idx += SIORBUFSIZE;
		}
		else{	/* ޥɤƼƤʤ */
			return E_NOMEM;
		}
	}
	/*
	 *  ǥåSIORBUFSIZEۤ
	 *  ȥμХåեȼǥåꤹ
	 */
	if (p_siopcb->rcv_idx >= SIORBUFSIZE && get_us1_rcvcnt2() == 0){
 		p_siopcb->rcv_idx -= SIORBUFSIZE;
		set_us1_rcvptr2((unsigned int) buf_ptr);
		set_us1_rcvcnt2(SIORBUFSIZE);
		p_siopcb->rcv_no++;
	}
	return cmd_len;
}

/*
 *  BLUETOOTH³֤Ф
 */
ER_UINT
bluetooth_get_connect_state(ID portid)
{
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);		/* ݡֹΥå */
	}
	return(get_siopcb(portid)->connect_state);
}

/*
 *  BLUETOOTH³֤ѹ
 */
ER
bluetooth_set_connect_state(ID portid, int_t state)
{
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);		/* ݡֹΥå */
	}
	get_siopcb(portid)->connect_state = state;
	return E_OK;
}

/*
 *  BLUETOOTHǥХΥꥻå׵
 *  ߥϥɥ餫¹Բǽ
 */
ER
bluetooth_reset(ID portid)
{
    SIOPCB  *p_siopcb;
	uint8_t *buf;
	int_t   cnt;

	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);		/* ݡֹΥå */
	}
	p_siopcb = get_siopcb(portid);
	/*
	 *  Ÿվ֤Ǥϼ¹Ԥʤ
	 */
	if((sil_rew_mem((void*)(TADR_PIO_BASE+TOFF_PIO_ODSR)) & BT_RST_PIN) == 0){
		return E_OK;
	}
	/*
	 *  ޥɥ⡼
	 */
	bluetooth_clear_arm7_cmd();
	/*
     *  BC4åפФ100ms֥ꥻå
	 */
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_CODR), BT_RST_PIN);
	buf = p_siopcb->siobuffer;
	for(cnt = 0 ; cnt < 100 ; cnt++){
		bluetooth_receive(portid, buf);
		sil_dly_nse(1000*1000);	/* 1msԤ */
	}
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_SODR), BT_RST_PIN);
	/*
	 * 5ô֤RESET INDICATIONԤԤ
	 */
	for(cnt = 0 ; cnt < 5000 ; cnt++){
		bluetooth_receive(portid, buf);
		/*
		 *  RESET INDICATIONȥåγǧ
		 */
		if ((buf[0] == 3) && (buf[1] == MSG_RESET_INDICATION) &&
			(buf[2] == 0xff) && (buf[3] == 0xe9))
			break;
		sil_dly_nse(1000*1000);	/* 1msԤ */
	}
	/*
	 *  ޥɥ⡼ɺ
	 */
	bluetooth_clear_arm7_cmd();
	bluetooth_set_connect_state(portid, BLUETOOTH_NO_INIT);
	return E_OK;
}

/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
    SIOPCB  *p_siopcb;
	unsigned long portpin, temp;
	int_t   i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    p_siopcb = siopcb_table;
    p_siopcb->p_siopinib = &siopinib_table[0];
    p_siopcb->openflag = false;
    p_siopcb->intflag  = false;
	p_siopcb->connect_state = BLUETOOTH_DEVICE_INITIALIZED;
	p_siopcb->rcv_idx  = 0;
	p_siopcb->rcv_no   = 0;
	p_siopcb->snd_stat[SND_EMPY] = 0x03;
	p_siopcb->snd_stat[SND_RDY]  = 0x00;
	p_siopcb->snd_stat[SND_OUT]  = 0x00;
	for(i = 0 ; i < NUM_SNDBUF ; i++){
		p_siopcb->snd_buf[i].id  = i;
		p_siopcb->snd_buf[i].len = 0;
	}
	p_siopcb->bcount   = 0;
	p_siopcb->obcount  = 0;

	sil_wrw_mem((void*)(TADR_PMC_BASE+TOFF_PMC_PCER), 1 << INTNO_US1_PID);	/* Uart1 clock on */
	portpin = BT_RX_PIN | BT_TX_PIN | BT_SCK_PIN | BT_RTS_PIN | BT_CTS_PIN;
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_PDR), portpin);	/* disable */
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_ASR), portpin);	/* select Peripheral A */

	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_US_CR), US_RSTSTA);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_US_CR), US_STTTO);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_US_RTOR), 10000);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_US_IDR), US_TIMEOUT);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_US_MR), US_USMODE_HWHSH |US_CLKS_MCK|US_CHRL_8|US_PAR_NO|US_NBSTOP_1|US_OVER);
	temp = (MCK/8/BAUD_RATE) | (((MCK/8) - ((MCK/8/BAUD_RATE) * BAUD_RATE)) / ((BAUD_RATE + 4)/8)) << 16;
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_US_BRGR), temp);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_PTCR), PDC_RXTDIS|PDC_TXTDIS);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_RCR), 0);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_TCR), 0);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_RNCR), 0);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_TNCR), 0);

	temp = sil_rew_mem((void*)(TADR_US1_BASE+TOFF_US_RHR));
	temp = sil_rew_mem((void*)(TADR_US1_BASE+TOFF_US_CSR));

	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_RPR), (unsigned long)&p_siopcb->rcv_buf[0][0]);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_RCR), SIORBUFSIZE);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_RNPR), (unsigned long)&p_siopcb->rcv_buf[1][0]);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_RNCR), SIORBUFSIZE);

	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_US_CR), US_RXEN|US_TXEN);
	sil_wrw_mem((void*)(TADR_US1_BASE+TOFF_PDC_PTCR), PDC_RXTEN|PDC_TXTEN);

	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_PDR), portpin);	/* disable */
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_ASR), portpin);	/* select Peripheral A */
	portpin = BT_CS_PIN | BT_RST_PIN;
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_PER), portpin);	/* enable */
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_OER), portpin);	/* output enable */
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_SODR), portpin);	/* set output data */
	portpin = BT_ARM7_CMD_PIN;
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_PUDR), portpin);	/* pull-up disable */
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_PER), portpin);	/* enable */
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_CODR), portpin);	/* clear output */
	sil_wrw_mem((void*)(TADR_PIO_BASE+TOFF_PIO_OER), portpin);	/* output enable */

	// Configure timer 01 as trigger for ADC, sample every 0.5ms
	sil_wrw_mem((void*)(TADR_PMC_BASE+TOFF_PMC_PCER), 1 << INTNO_TC1_PID);/* Timer1 clock on */
	sil_wrw_mem((void*)(TADR_TC1_BASE+TOFF_TC_CCR), TC_CLKDIS);
	sil_wrw_mem((void*)(TADR_TC1_BASE+TOFF_TC_IDR), 0xFFFFFFFF);
	temp = sil_rew_mem((void*)(TADR_TC1_BASE+TOFF_TC_SR));
	sil_wrw_mem((void*)(TADR_TC1_BASE+TOFF_TC_CMR), TC_WAVE|TC_WAVESEL10|TC_ACPA_SET|TC_ACPC_CLEAR|TC_ASWTRG_SET);
	sil_wrw_mem((void*)(TADR_TC1_BASE+TOFF_TC_RC), (CLOCK_FREQUENCY/2)/2000);
	sil_wrw_mem((void*)(TADR_TC1_BASE+TOFF_TC_RA), (CLOCK_FREQUENCY/2)/4000);
	sil_wrw_mem((void*)(TADR_TC1_BASE+TOFF_TC_CCR), TC_CLKEN);
	sil_wrw_mem((void*)(TADR_TC1_BASE+TOFF_TC_CCR), TC_SWTRG);

	sil_wrw_mem((void*)(TADR_PMC_BASE+TOFF_PMC_PCER), 1 << INTNO_ADC_PID);/* ADC clock on */
	sil_wrw_mem((void*)(TADR_ADC_BASE+TOFF_ADC_MR), 0x00000000);
	temp = ADC_TRGEN|ADC_TRGSEL_TIOA1;
	sil_wrw_mem((void*)(TADR_ADC_BASE+TOFF_ADC_MR), temp);
	temp |= 0x00003F00;								/* set PRESCAL */
	sil_wrw_mem((void*)(TADR_ADC_BASE+TOFF_ADC_MR), temp);
	temp |= 0x00020000;								/* set STARTUP */
	sil_wrw_mem((void*)(TADR_ADC_BASE+TOFF_ADC_MR), temp);
	temp |= 0x09000000;								/* set SHTIM */
	sil_wrw_mem((void*)(TADR_ADC_BASE+TOFF_ADC_MR), temp);
	sil_wrw_mem((void*)(TADR_ADC_BASE+TOFF_ADC_CHER), ADC_CH6|ADC_CH4);
}


/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB  *p_siopcb = get_siopcb(siopid);
    const SIOPINIB  *siopinib;
    bool_t  opnflg;
	unsigned long   tbase;
    ER      ercd;

    /*
     *  ץ󤷤ݡȤ뤫opnflgɤǤ
     */
    opnflg = p_siopcb->openflag;

    /*
     *  ǥХ¸Υץ
     */
    siopinib = p_siopcb->p_siopinib;
	p_siopcb->exinf = exinf;
	tbase  = (unsigned long)siopinib->time_base;

	bluetooth_reset(siopid);

    /*  å֥͡ */
    sil_wrw_mem((void*)(TADR_PMC_BASE+TOFF_PMC_PCER), (1<<INTNO_TC2_PID));
    /*   */
    sil_wrw_mem((void*)(tbase+TOFF_TC_CCR), TC_CLKDIS);
    sil_wrw_mem((void*)(tbase+TOFF_TC_IDR), 0xFFFFFFFF);
    /*  ͤ򥻥å */
    sil_wrw_mem((void*)(tbase+TOFF_TC_CMR), TC_CLKS_MCK8);	/* 47,923,200Hz/8=5,990,400Hz */
    sil_wrw_mem((void*)(tbase+TOFF_TC_CMR), sil_rew_mem((void*)(tbase+TOFF_TC_CMR)) | TC_WAVESEL10);
    sil_wrw_mem((void*)(tbase+TOFF_TC_RC), 59900);			/* 10ms */
    /*  ߤζػ  */
	uart_disable_rcv(p_siopcb);
	uart_disable_send(p_siopcb);
    /*  ȥ   */
    sil_wrw_mem((void*)(tbase+TOFF_TC_CCR), (TC_CLKEN|TC_SWTRG));

    /*
     *  ꥢI/OߤΥޥ롥
     */
    if (!opnflg) {
        ercd = ena_int(INTNO_SIO);
        assert(ercd == E_OK);
        ercd = ena_int(INTNO_STC);
        assert(ercd == E_OK);
    }
    return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
    /*
     *  ǥХ¸Υ
     */
    const SIOPINIB  *p_siopinib;

    p_siopinib = p_siopcb->p_siopinib;
    /* ߤ  */
	uart_disable_rcv(p_siopcb);
    /*  */
    sil_wrw_mem((void*)(p_siopinib->time_base+TOFF_TC_CCR), TC_CLKDIS);
    sil_wrw_mem((void*)(p_siopinib->time_base+TOFF_TC_IDR), 0xFFFFFFFF);
	sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_CR), US_RSTRX|US_RSTTX|US_RXDIS|US_TXDIS);
    p_siopcb->openflag = false;
    
    /*
     *  ꥢI/Oߤޥ롥
     */
    dis_int(INTNO_SIO);
}

/*
 *  SIOγߥϥɥ
 */
void
int_sio(void)
{
    SIOPCB *p_siopcb = &(siopcb_table[0]);

	p_siopcb->intflag = true;
    if (uart_putready(p_siopcb)) {
		if(p_siopcb->connect_state != BLUETOOTH_STREAM){
			/*
			 *  STREAM̿Ǥʤ祳ޥԤ
			 */
			bluetooth_tx_int(p_siopcb);
		}
		else{
	        /*
    	     *  ǽХå롼ƤӽФ
        	 */
	        sio_irdy_snd(p_siopcb->exinf);
		}
    }
	p_siopcb->intflag = false;
}

void
int_timer2(void)
{
    SIOPCB *p_siopcb = &(siopcb_table[0]);

    sil_rew_mem((void*)(TADR_TC2_BASE+TOFF_TC_SR));
    if(p_siopcb->connect_state == BLUETOOTH_STREAM){
		if(uart_getready(p_siopcb)){
	        /*
    	     *  ΥХå롼ƤӽФ
        	 */
	        sio_irdy_rcv(p_siopcb->exinf);
    	}
		if(p_siopcb->bcount > 0	&& uart_putready(p_siopcb)){
			iloc_cpu();
			if(p_siopcb->bcount == p_siopcb->obcount){
				p_siopcb->obcount = 0;
				uart_puts(p_siopcb, p_siopcb->siobuffer, p_siopcb->bcount);    /* DMAžϤ */
				p_siopcb->bcount  = 0;         /* Хåեʸꥻå */
			}
			else
				p_siopcb->obcount = p_siopcb->bcount;
			iunl_cpu();
		}
	}
}


/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char_t c)
{
	/*
	 *  bluetoothSTREAM³Ƥʤʤ
	 */
	if(!siopcb->intflag && siopcb->connect_state != BLUETOOTH_STREAM)
		return true;
	/*
	 *  ǽɤå
	 */
	if(siopcb->bcount < SIOBUFSIZE && uart_putready(siopcb)) {
		if(!siopcb->intflag)
			loc_cpu();
		siopcb->siobuffer[siopcb->bcount] = c;	/* Хåեʸ */
		siopcb->bcount++;						/* Хåեʸ򥤥󥯥 */
		if(c == '\n' || siopcb->bcount >= SIOBUFSIZE) {
			/*
			 * 	ʸξ or Хåեեξ
			 *  STREAM⡼ɤԤ
			 */
			siopcb->obcount = 0;		/* ˥ꤷơtimerˤž */
			uart_puts(siopcb, siopcb->siobuffer, siopcb->bcount);
			siopcb->bcount  = 0;		/* Хåեʸꥻå */
		}
		if(!siopcb->intflag)
			unl_cpu();
		return true;
	}
    return false;
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
	int bytes_ready;
	int c = 0;
	unsigned char *p;

	p = &(siopcb->rcv_buf[siopcb->rcv_no&1][0]);

	if (get_us1_rcvcnt2() == 0)
	  	bytes_ready = SIORBUFSIZE*2 - get_us1_rcvcnt1();
	else
		bytes_ready = SIORBUFSIZE - get_us1_rcvcnt1();

	if (bytes_ready > siopcb->rcv_idx)
	  	c = (int) p[siopcb->rcv_idx++];
	/*
	 *  ǥåSIORBUFSIZEۤ
	 *  ȥμХåեȼǥåꤹ
	 */
	if (siopcb->rcv_idx >= SIORBUFSIZE && get_us1_rcvcnt2() == 0){
 		siopcb->rcv_idx -= SIORBUFSIZE;
		set_us1_rcvptr2((unsigned int)p);
		set_us1_rcvcnt2(SIORBUFSIZE);
		siopcb->rcv_no++;
	}
	return c;
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
    case SIO_RDY_SND:
        uart_enable_send(siopcb);
        break;
    case SIO_RDY_RCV:
        uart_enable_rcv(siopcb);
        break;
    }
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
    case SIO_RDY_SND:
        uart_disable_send(siopcb);
        break;
    case SIO_RDY_RCV:
        uart_disable_rcv(siopcb);
        break;
    }
}
