/**
 ******************************************************************************
 **	t@C : sample.c
 **
 **	Tv       : 2֓|UqCg[X{bgTOPPERS/JSPpTvvO
 **
 ******************************************************************************
 **/
#include <s_services.h>
#include "sample.h"
#include "kernel_id.h"
#include "ecrobot_base.h"
#include "ecrobot_interface.h"
#include "balancer.h"	/* |Uqpwb_t@C */

/* L̃p[^̓ZT/ɍ킹ă`[jOKv܂ */
#define GYRO_OFFSET         589 /* WCZTItZbgl(px0[deg/sec])  */
#define WHITE               521 /* F̌ZTl */
#define BLACK		        632 /* F̌ZTl */
#define FORWARD_MAX         100	/* Oiő */
#define FORWARD_MINI        50	/* Oiŏ */
#define FORWARD_DENO        35	/* Oi */
#define TURN_MAX            50	/* ]ő */
#define TURN_DENO           50	/* ] */
#define STOPWAIT            8	/* ~܂ł̎(*40ms) */

#define TAIL_ANGLE_STAND_UP 106 /* S~̊px[x] */
#define TAIL_ANGLE_DRIVE      0 /* oXs̊px[x] */
#define P_GAIN             2.5F /* S~p[^W */
#define PWM_ABS_MAX          60 /* S~p[^PWM΍ől */

static char mstate;				/* ŝ̏ */
static char keystate;			/* ^b`ZT[̏ */
static char edge = 1;			/* GbW̑I */
static int  balance, fdeno;
static int  wtime = 0;

//*****************************************************************************
// ֐ : tail_control
//   : angle ([^ڕWpx[x])
// Ԃl : 
// Tv : s̊S~p[^̊px
//*****************************************************************************
static void tail_control(signed int angle)
{
	float pwm = (float)(angle - nxt_motor_get_count(NXT_PORT_A))*P_GAIN; /* ᐧ */
	/* PWMo͖Oa */
	if(pwm > PWM_ABS_MAX)
		pwm = PWM_ABS_MAX;
	else if(pwm < -PWM_ABS_MAX)
		pwm = -PWM_ABS_MAX;
	nxt_motor_set_speed(NXT_PORT_A, (signed char)pwm, 1);
}

//*****************************************************************************
// ֐ : get_command
//   : parg (̈|C^)
// Ԃl : R}hA[ŃR}hȂ
// Tv : R}hƈbluetoothǂݎ
//*****************************************************************************
static char get_command(signed int *parg)
{
	static int arg  = 0;
	static int sign = 1;
	T_SERIAL_RPOR rpor;
	char buf[2];
	ER   ercd;
	char cmd = 0;

	*parg = 0;
	ercd = serial_ref_por(CONSOLE_PORTID, &rpor);
	if(ercd == E_OK && rpor.reacnt){
		serial_rea_dat(CONSOLE_PORTID, buf, 1);
		if(buf[0] == '-')
			sign = -sign;
		else if(buf[0] >= '0' && buf[0] <= '9')
			arg = arg * 10 + (buf[0] - '0');
		else if(buf[0] >= 'A'){
			if(buf[0] <= 'Z')
				buf[0] += 0x20;
			if(buf[0] >= 'a' && buf[0] <= 'z'){
				cmd = buf[0];
				*parg = arg * sign;
				arg  = 0;
				sign = 1;
			}
		}
	}
	return cmd;
}

//*****************************************************************************
// TASK			: cyc0
// DESCRIPTION 	: 4msec periodical Task handler
//*****************************************************************************
void cyc0(VP_INT exinf)
{
	static int dispcount = 0;
	if(mstate > MWAIT)
		isig_sem(EVT_MAIN);
	if(++dispcount >=10){
		syscall(isig_sem(EVT_DISP));
		dispcount = 0;
	}
}

//*****************************************************************************
// ^XN	: TaskMain
// Tv		: C^XN
//*****************************************************************************
void TaskMain(VP_INT exinf)
{
	signed int  forward;      /* Oi: -100(i)`100(Oi)   */
	signed char turn;         /* 񖽗: -100()`100(E) */
	signed char pwm_L, pwm_R; /* E[^PWMo */
	int ses, def;

	mstate = MWAIT;
	ecrobot_set_light_sensor_active(NXT_PORT_S3);       /* ZTԐFLEDON */
	while(mstate < MRUNNING || mstate >= MSTOP1){		/* ^b`ZTҋ@ */
		tail_control(TAIL_ANGLE_STAND_UP);	/* S~ppxɐ */
		dly_tsk(10);
	}

	balance_init();							/* |Uq䏉 */
	nxt_motor_set_count(NXT_PORT_C, 0);		/* [^GR[_Zbg */
	nxt_motor_set_count(NXT_PORT_B, 0);		/* E[^GR[_Zbg */
	forward = FORWARD_MINI;					/* Oi */
	while(mstate < MPREWAIT){
		if(mstate == MRUNNING){
			tail_control(TAIL_ANGLE_DRIVE); /* oXsppxɐ */
			ses = ecrobot_get_light_sensor(NXT_PORT_S3);
			def = ses - balance;
			if(def > -23 && def < 23)
				turn = (def * 30) / TURN_DENO;
			else
				turn = (def * forward) / TURN_DENO;
			if (turn  > TURN_MAX)
				turn = TURN_MAX;  /* E */
			else if(turn < (-TURN_MAX))
				turn = (-TURN_MAX); /*  */
			forward = (turn * TURN_MAX) / fdeno;
			forward = forward >= 0 ? FORWARD_MAX - forward : FORWARD_MAX + forward;
			if(forward < FORWARD_MINI)
				forward = FORWARD_MINI;
			turn *= edge;
			syslog_4(LOG_INFO, "ses(%d) def(%d) forward(%d) turn(%d)", ses, def, forward, (int)turn);
		}
		else if(mstate == MSTOP1){
			nxt_motor_set_count(NXT_PORT_A, 0);	/* S~p[^GR[_Zbg */
			forward = -20;						/* ~ */
			turn = 0;
		}
		else{
			tail_control(TAIL_ANGLE_STAND_UP-(MPREWAIT-mstate)*2);	/* S~ppxɐ */
			forward = 0;
		}

		/* |Uq(forward = 0, turn = 0ŐÎ~oX) */
		balance_control(
			(float)forward,                              /* Oi                 */
			(float)turn,                                 /* 񖽗                   */
			(float)ecrobot_get_gyro_sensor(NXT_PORT_S1), /* WCZTl           */
			(float)GYRO_OFFSET,                          /* WCZTItZbgl */
			(float)nxt_motor_get_count(NXT_PORT_C),      /* [^]px[deg]      */
			(float)nxt_motor_get_count(NXT_PORT_B),      /* E[^]px[deg]      */
			(float)ecrobot_get_battery_voltage(),        /* obed[mV]           */
			&pwm_L,  /* [^PWMo͒l */
			&pwm_R); /* E[^PWMo͒l */
		ecrobot_set_motor_speed(NXT_PORT_C, pwm_L);      /* [^PWMo̓Zbg */
		ecrobot_set_motor_speed(NXT_PORT_B, pwm_R);      /* E[^PWMo̓Zbg */

		wai_sem(EVT_MAIN);	/* 4MS҂ */
	}

	mstate = MINIT;
	ecrobot_set_motor_speed(NXT_PORT_C, 0);      /* [^PWMo̓Zbg */
	ecrobot_set_motor_speed(NXT_PORT_B, 0);      /* E[^PWMo̓Zbg */
	ecrobot_sound_tone(1000, 200, 50);
	act_tsk(TSK_SELF);
}

//*****************************************************************************
// ^XN	: TaskDisp
// Tv		: \^XN
//*****************************************************************************
void TaskDisp(VP_INT exinf)
{
	int log = LOG_NOTICE;
	char key;
	int  arg;
	SYSTIM ctime;

	vmsk_log(LOG_UPTO(LOG_NOTICE), LOG_UPTO(LOG_EMERG));
	syscall(serial_ctl_por(CONSOLE_PORTID,	(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));
	show_splash_screen();
	ecrobot_init_nxtstate();
	ecrobot_init_sensors();
	ecrobot_init_sonar_sensor(NXT_PORT_S2); /* gZT(I2CʐM) */
	show_main_screen();
	display_status_bar();
	ecrobot_sound_tone(1000, 200, 50);
	mstate = MINIT;
	balance = (WHITE + BLACK)/2;
	fdeno   = FORWARD_DENO;
	keystate = ecrobot_get_touch_sensor(NXT_PORT_S4);
	nxt_motor_set_count(NXT_PORT_A, 0);		/* S~p[^GR[_Zbg */
	sta_cyc(CYC0);
	act_tsk(TASK0);
	while(1){
		ecrobot_poll_nxtstate();
		distance = ecrobot_get_sonar_sensor(NXT_PORT_S2);
		if((key = get_command(&arg)) != 0){
			if(key == 'g' && arg >= 0 && mstate == MWAIT){
				if((arg & 1) != 0)
					edge = -1;
				else
					edge = 1;
				mstate = MRUNNING+arg/2;
			}
			else if(key == 's' && mstate >= MRUNNING && mstate < MSTOP1){
				mstate = MSTOP1;
				wtime = STOPWAIT;
			}
			else if(key == 'b'){
				if(arg >= WHITE && arg <= BLACK)
					balance = arg;
				else
					balance = ecrobot_get_light_sensor(NXT_PORT_S3);
			}
			else if(key == 'i' && arg >= 3 && arg <= 7){
				log = arg;
				vmsk_log(LOG_UPTO(log), LOG_UPTO(LOG_EMERG));
			}
			else if(key == 'f')
				fdeno = arg;
			get_tim(&ctime);
			syslog_5(LOG_NOTICE, "balance(%d) fdeno(%d) edge(%d) log(%d) time(%d)", balance, fdeno, (int)edge, log, ctime);
		}
		if(distance < 30)
			syslog_1(LOG_NOTICE, "distance(%d)", distance);
		key = ecrobot_get_touch_sensor(NXT_PORT_S4);
		if(key != keystate){	/* KEYZT[̌m */
			if(key != 0){
				if(mstate == MWAIT)
					mstate = MRUNNING;
				else if(mstate >= MRUNNING && mstate < MSTOP1){
					mstate = MSTOP1;
					wtime = STOPWAIT;
				}
			}
			keystate = key;
		}
		if(wtime > 0){
			if(--wtime <= 0 && mstate >= MSTOP1 && mstate < MPREWAIT){
				if(++mstate != MPREWAIT)
					wtime = STOPWAIT;
			}
		}

		ecrobot_status_monitor("sample JSP"); /* LCD display */
		wai_sem(EVT_DISP);	/* 40MS҂ */
	}
}

