/**
 ******************************************************************************
 **	t@C : sample.c
 **
 **	Tv       : 2֓|UqCg[X{bgTOPPERS/JSPpTvvO
 **
 ******************************************************************************
 **/
#include <s_services.h>
#include "control.h"
#include "kernel_id.h"
#include "ecrobot_base.h"
#include "ecrobot_interface.h"
#include "balancer.h" /* |Uqpwb_t@C */

/* L̃p[^̓ZT/ɍ킹ă`[jOKv܂ */
#define GYRO_OFFSET  589 /* WCZTItZbgl(px0[deg/sec])  */
#define WHITE		 530 /* F̌ZTl */
#define BLACK		 690 /* F̌ZTl */
#define DEFFORECOUNT 800
#define DEFTURNCOUNT 4
#define TURN_BASE    0	 /* TURN̊ */

static int gyro_offset;
static signed char forward;	/* Oi: -100(i)`100(Oi)   */
static signed char turn;	/* 񖽗: -100()`100(E) */
static unsigned char fore_count;
static unsigned char turn_count;
//*****************************************************************************
// TASK			: cyc0
// DESCRIPTION 	: 4msec periodical Task handler
//*****************************************************************************
void cyc0(VP_INT exinf)
{
	isig_sem(EVT_SEM);
}

//*****************************************************************************
// ^XN	: TaskMain
// Tv		: C^XN
//*****************************************************************************
void TaskMain(VP_INT exinf)
{
	signed char pwm_L, pwm_R; /* E[^PWMo */

	while (ecrobot_get_touch_sensor(NXT_PORT_S1) == 0){ /* ^b`ZTҋ@ */
		dly_tsk(10);
	}
	ecrobot_set_light_sensor_active(NXT_PORT_S3);       /* ZTԐFLEDON */
	gyro_offset = ecrobot_get_gyro_sensor(NXT_PORT_S4);
	syslog(LOG_NOTICE, "gyro offset def=%d cur=%d", GYRO_OFFSET, gyro_offset);

	balance_init();						/* |Uq䏉 */
	nxt_motor_set_count(NXT_PORT_C, 0); /* [^GR[_Zbg */
	nxt_motor_set_count(NXT_PORT_B, 0); /* E[^GR[_Zbg */
	forward = 0;						/* Oi */
	turn = 0;
	fore_count = 0;
	turn_count = 0;
	sta_cyc(CYC0);
	while(1){
		if(fore_count > 0)
			fore_count--;
		if(turn_count > 0)
			turn_count--;

		/* |Uq(forward = 0, turn = 0ŐÎ~oX) */
		balance_control(
			(float)forward,                              /* Oi                 */
			(float)(turn+TURN_BASE),                     /* 񖽗                   */
			(float)ecrobot_get_gyro_sensor(NXT_PORT_S4), /* WCZTl           */
			(float)gyro_offset,                          /* WCZTItZbgl */
			(float)nxt_motor_get_count(NXT_PORT_C),      /* [^]px[deg]      */
			(float)nxt_motor_get_count(NXT_PORT_B),      /* E[^]px[deg]      */
			(float)ecrobot_get_battery_voltage(),        /* obed[mV]           */
			&pwm_L,  /* [^PWMo͒l */
			&pwm_R); /* E[^PWMo͒l */
		nxt_motor_set_speed(NXT_PORT_C, pwm_L, 1); /* [^PWMo̓Zbg */
		nxt_motor_set_speed(NXT_PORT_B, pwm_R, 1); /* E[^PWMo̓Zbg */

		wai_sem(EVT_SEM);	/* 4MS҂ */
	}
}

//*****************************************************************************
// ^XN	: TaskDisp
// Tv		: \^XN
//*****************************************************************************
void TaskDisp(VP_INT exinf)
{
	T_SERIAL_RPOR rpor;
	UB buf[4];
	ER ercd;
	int distance;

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG));
	syscall(serial_ctl_por(CONSOLE_PORTID,	(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));
	show_splash_screen();
	ecrobot_init_nxtstate();
	ecrobot_init_sensors();
	ecrobot_init_sonar_sensor(NXT_PORT_S2);
	show_main_screen();
	display_status_bar();
	ecrobot_sound_tone(1000, 200, 50);
	act_tsk(TASK0);
	while(1){
		ecrobot_poll_nxtstate();
		distance = ecrobot_get_sonar_sensor(NXT_PORT_S2);
		ercd = serial_ref_por(CONSOLE_PORTID, &rpor);
		if(ercd == E_OK && rpor.reacnt){
			serial_rea_dat(CONSOLE_PORTID, buf, 1);
			if(buf[0] == 'i'){
				if(forward < 100)
					forward += 20;
				fore_count = DEFFORECOUNT;
				syslog(LOG_NOTICE, "[foreword]foreward[%d] turn[%d]", (int)forward, (int)turn);
			}
			else if(buf[0] == 'm'){
				if(forward > -100)
					forward -= 20;
				fore_count = DEFFORECOUNT;
				syslog(LOG_NOTICE, "[backword]foreward=%d turn[%d]", (int)forward, (int)turn);
			}
			else if(buf[0] == 'k'){
				if(turn > -60)
					turn -= 30;
				turn_count = DEFTURNCOUNT;
 				syslog(LOG_NOTICE, "[right]foreward=%d turn[%d]", (int)forward, (int)turn);
			}
			else if(buf[0] == 'j'){
				if(turn < 60)
					turn += 30;
				turn_count = DEFTURNCOUNT;
				syslog(LOG_NOTICE, "[left]foreward=%d turn[%d]", (int)forward, (int)turn);
			}
            else{
				int light = ecrobot_get_light_sensor(NXT_PORT_S3);
				syslog(LOG_NOTICE, "[display]foreward=%d turn[%d] gyio[%d] light[%d]", (int)forward, (int)turn, (int)distance, (int)light);
			}
		}
		if(fore_count == 0)
			forward = 0;
		if(turn_count == 0)
			turn = 0;
		if(distance < 30 && forward > 0){
			syslog(LOG_NOTICE, "distance=%d foreward %d->0", distance, forward);
			ecrobot_sound_tone(500, 200, 100);
			fore_count = 10;
		}
		ecrobot_status_monitor("sample JSP"); /* LCD display */
		dly_tsk(40U); /* 40msec wait */
	}
}

