/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2010      by GJ Designing Center Print Business Group
 *                             RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: flash_io.S,v 1.1 2010/06/26 21:18:56 roi Exp $
 */

/*
 *  MEMORY CONTROLLER (MC)
 */
#define TADR_MC_BASE     0xFFFFFF00		/* Memory Controller BASE address */
#define TOFF_MC_FCR      0x0064			/* MC Flash Command Register (W) */
#define TOFF_MC_FSR      0x0068			/* MC Flash Status Register (R) */

#define FLASH_BASE_ADDRESS  0x100000
#define FLASH_PAGE_SIZE     256
#define FLASH_START_PAGE    128 /* 0x100000 + 32Kbyte(128*256) = 0x108000 */

        .section .rtext,"a"
        .code 32
        .align 0
        .global flash_write_page

flash_write_page:
        cmp     r0, #1024	/* 0x400 */
        movge   r0, #0		/* 0x0 */
        bxge    lr
        mrs     r3, CPSR
        orr     r3, r3, #128	/* 0x80 */
        msr     CPSR_fc, r3
        ldr     r2,=(TADR_MC_BASE+TOFF_MC_FSR)

flash_write_page_1:
        ldr     r3, [r2]
        tst     r3, #1		/* 0x1 */
        beq     flash_write_page_1
        mov     ip, #0		/* 0x0 */

flash_write_page_2:
        ldr     r2, [ip, r1]
        add     r3, ip, #( FLASH_BASE_ADDRESS+FLASH_START_PAGE*FLASH_PAGE_SIZE)	/* 0x108000 */
        add     ip, ip, #4	/* 0x4 */
        cmp     ip, #FLASH_PAGE_SIZE	/* 0x100 */
        str     r2, [r3]
        bne     flash_write_page_2
        mov     r3, r0, lsl #22
        mov     r3, r3, lsr #22
        mov     r3, r3, lsl #8
        add     r3, r3, #0x5a000000
        add     r3, r3, #1	/* 0x1 */
        ldr     r2,=(TADR_MC_BASE+TOFF_MC_FCR)
        str     r3, [r2]
        ldr     r2,=(TADR_MC_BASE+TOFF_MC_FSR)

flash_write_page_3:
        ldr     r3, [r2]
        tst     r3, #1		/*  0x1 */
        beq     flash_write_page_3
        mrs     r3, CPSR
        bic     r3, r3, #128	/* 0x80 */
        msr     CPSR_fc, r3
        mov     r0, #1		/* 0x1 */
        bx      lr


