/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006-2007 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2009-2010 by GJ Designing Center Print Business Group
 *                             RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: bluetooth.c,v 1.1 2010/02/20 19:32:22 roi Exp $
 *  
 */

/*
 * At91sam7s ǽѥɥ饤
 */
#include <mindstormsnxt.h>

#define	TADR_US1_BASE   (TADR_US_BASE+US_WINDOW)
#define TADR_TC1_BASE   (TADR_TC_BASE+TC_WINDOW)
#define TADR_TC2_BASE   (TADR_TC_BASE+TC_WINDOW*2)

typedef void * VP;

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define get_us1_rcvcnt1()   sil_rew_mem((VP)(TADR_US1_BASE+TOFF_PDC_RCR))
#define get_us1_rcvcnt2()   sil_rew_mem((VP)(TADR_US1_BASE+TOFF_PDC_RNCR))
#define set_us1_rcvcnt2(a)  sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_RNCR), a)
#define set_us1_rcvptr2(a)  sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_RNPR), a)


#define BT_RX_PIN        AT91S_PIO_PA21
#define BT_TX_PIN        AT91S_PIO_PA22
#define BT_SCK_PIN       AT91S_PIO_PA23
#define BT_RTS_PIN       AT91S_PIO_PA24
#define BT_CTS_PIN       AT91S_PIO_PA25
#define BT_CS_PIN        AT91S_PIO_PA31
#define BT_RST_PIN       AT91S_PIO_PA11


#define MSG_RESET_INDICATION 20


#define BAUD_RATE 460800

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
static const UINT32 bluetooth_base[TNUM_BTP] = {
	TADR_US1_BASE,
};

static BTCB  btcb_table[TNUM_BTP];

/*
 * ʸǤ뤫?
 */
Inline BOOL
uart_putready(BTCB *btcb)
{
	return (sil_rew_mem((VP)(btcb->uart_base+TOFF_PDC_TNCR)) == 0
				&& sil_rew_mem((VP)(btcb->uart_base+TOFF_PDC_TCR)) == 0);
}

/*
 *  ʸν񤭹
 */
Inline void
bt_puts(BTCB *btcb, UINT8 *buf, INT16 len)
{
	/*
	 *  DMAȥˡǡΥɥ쥹ȥΤ餻
	 */
	sil_wrw_mem((VP)(btcb->uart_base+TOFF_PDC_TNPR), (unsigned long)buf);
    sil_wrw_mem((VP)(btcb->uart_base+TOFF_PDC_TNCR), len);
}

/*
 *  ߵ
 */
Inline void
bt_enable_send(BTCB *btcb)
{
    sil_wrw_mem((VP)(btcb->uart_base+TOFF_US_IER), US_TXBUFE);
}

/*
 *  ߶ػ
 */
Inline void
bt_disable_send(BTCB *btcb)
{
	sil_wrw_mem((VP)(btcb->uart_base+TOFF_US_IDR), US_TXBUFE);
}


/*
 *  IDΰζѥåֹ֤
 */
static INT32
bluetooth_search_packet(BTCB *btcb, INT32 id)
{
	INT32 no;

	if(btcb->snd_stat[id] == 0)
		return -1;
	for(no = 0 ; no < 8 ; no++){
		if(btcb->snd_stat[id] & (1<<no))
			return no;
	}
	return -1;
}

/*
 *  ԤѥåȤ
 */
static void
bluetooth_tx_int(BTCB *btcb)
{
	BTPACKET *p;
	INT32    no;

	btcb->snd_stat[SND_EMPY] |= btcb->snd_stat[SND_OUT];
	btcb->snd_stat[SND_OUT] = 0;
	if((no = bluetooth_search_packet(btcb, SND_RDY)) >= 0){
		btcb->snd_stat[SND_OUT] |= 1<<no;
		btcb->snd_stat[SND_RDY] &= ~(1<<no);
		p = &btcb->snd_buf[no];
		bt_puts(btcb, p->buf, p->len);
	}
	else{
		bt_disable_send(btcb);
	}
}

/*
 *  BLUETOOTHǥХ
 */
void bluetooth_init(void)
{
	BTCB   *btcb;
	UINT32 portpin, temp;
	INT32  id, i;

	for(id = 0 ; id < TNUM_BTP ; id++){
		btcb = &btcb_table[id];
		memset(btcb, 0, sizeof(BTCB));
		btcb->uart_base = bluetooth_base[id];
	}

	sil_wrw_mem((VP)(TADR_PMC_BASE+TOFF_PMC_PCER), 1 << IRQ_US1_PID);	/* Uart1 clock on */
	portpin = BT_RX_PIN | BT_TX_PIN | BT_SCK_PIN | BT_RTS_PIN | BT_CTS_PIN;
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_PDR), portpin);	/* disable */
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_ASR), portpin);	/* select Peripheral A */

	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_US_CR), US_RSTSTA);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_US_CR), US_STTTO);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_US_RTOR), 10000);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_US_IDR), US_TIMEOUT);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_US_MR), US_USMODE_HWHSH |US_CLKS_MCK|US_CHRL_8|US_PAR_NO|US_NBSTOP_1|US_OVER);
	temp = (MCK/8/BAUD_RATE) | (((MCK/8) - ((MCK/8/BAUD_RATE) * BAUD_RATE)) / ((BAUD_RATE + 4)/8)) << 16;
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_US_BRGR), temp);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_PTCR), PDC_RXTDIS|PDC_TXTDIS);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_RCR), 0);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_TCR), 0);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_RNCR), 0);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_TNCR), 0);

	temp = sil_rew_mem((VP)(TADR_US1_BASE+TOFF_US_RHR));
	temp = sil_rew_mem((VP)(TADR_US1_BASE+TOFF_US_CSR));

	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_RPR), (unsigned long)&btcb->rcv_buf[0][0]);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_RCR), SIORBUFSIZE);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_RNPR), (unsigned long)&btcb->rcv_buf[1][0]);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_RNCR), SIORBUFSIZE);

	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_US_CR), US_RXEN|US_TXEN);
	sil_wrw_mem((VP)(TADR_US1_BASE+TOFF_PDC_PTCR), PDC_RXTEN|PDC_TXTEN);

	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_PDR), portpin);	/* disable */
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_ASR), portpin);	/* select Peripheral A */
	portpin = BT_CS_PIN | BT_RST_PIN;
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_PER), portpin);	/* enable */
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_OER), portpin);	/* output enable */
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_SODR), portpin);/* set output data */
	portpin = BT_ARM7_CMD_PIN;
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_PUDR), portpin);/* pull-up disable */
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_PER), portpin);	/* enable */
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_CODR), portpin);/* clear output */
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_OER), portpin);	/* output enable */

	// Configure timer 01 as trigger for ADC, sample every 0.5ms
	sil_wrw_mem((VP)(TADR_PMC_BASE+TOFF_PMC_PCER), 1 << IRQ_TC1_PID);	/* Timer1 clock on */
	sil_wrw_mem((VP)(TADR_TC1_BASE+TOFF_TC_CCR), TC_CLKDIS);
	sil_wrw_mem((VP)(TADR_TC1_BASE+TOFF_TC_IDR), 0xFFFFFFFF);
	temp = sil_rew_mem((VP)(TADR_TC1_BASE+TOFF_TC_SR));
	sil_wrw_mem((VP)(TADR_TC1_BASE+TOFF_TC_CMR), TC_WAVE|TC_WAVESEL10|TC_ACPA_SET|TC_ACPC_CLEAR|TC_ASWTRG_SET);
	sil_wrw_mem((VP)(TADR_TC1_BASE+TOFF_TC_RC), (CLOCK_FREQUENCY/2)/2000);
	sil_wrw_mem((VP)(TADR_TC1_BASE+TOFF_TC_RA), (CLOCK_FREQUENCY/2)/4000);
	sil_wrw_mem((VP)(TADR_TC1_BASE+TOFF_TC_CCR), TC_CLKEN);
	sil_wrw_mem((VP)(TADR_TC1_BASE+TOFF_TC_CCR), TC_SWTRG);

	sil_wrw_mem((VP)(TADR_PMC_BASE+TOFF_PMC_PCER), 1 << IRQ_ADC_PID);	/* ADC clock on */
	sil_wrw_mem((VP)(TADR_ADC_BASE+TOFF_ADC_MR), 0x00000000);
	temp = ADC_TRGEN|ADC_TRGSEL_TIOA1;
	sil_wrw_mem((VP)(TADR_ADC_BASE+TOFF_ADC_MR), temp);
	temp |= 0x00003F00;								/* set PRESCAL */
	sil_wrw_mem((VP)(TADR_ADC_BASE+TOFF_ADC_MR), temp);
	temp |= 0x00020000;								/* set STARTUP */
	sil_wrw_mem((VP)(TADR_ADC_BASE+TOFF_ADC_MR), temp);
	temp |= 0x09000000;								/* set SHTIM */
	sil_wrw_mem((VP)(TADR_ADC_BASE+TOFF_ADC_MR), temp);
	sil_wrw_mem((VP)(TADR_ADC_BASE+TOFF_ADC_CHER), ADC_CH6|ADC_CH4);
}

/*
 *  BLUETOOTHǥХץ
 */
BTCB *blutooth_open_device(UINT32 portid)
{
	BTCB   *btcb;
	UINT32 portpin, temp;
	INT32  i;

	if(portid >= TNUM_BTP)
		return 0;
	btcb = &btcb_table[portid];
	if(btcb->open_flag)
		return 0;
    btcb->intflag  = FALSE;
	btcb->open_flag= TRUE;
	btcb->rcv_idx  = 0;
	btcb->rcv_no   = 0;
	btcb->snd_stat[SND_EMPY] = 0x03;
	btcb->snd_stat[SND_RDY]  = 0x00;
	btcb->snd_stat[SND_OUT]  = 0x00;
	for(i = 0 ; i < NUM_SNDBUF ; i++){
		btcb->snd_buf[i].id  = i;
		btcb->snd_buf[i].len = 0;
	}

	bluetooth_reset(btcb);

#if 0	/* ROI DEBUG */
    /*  å֥͡ */
    sil_wrw_mem((VP)(tbase+TOFF_PMC_PCER), (1<<IRQ_TC2_PID));
    /*   */
    sil_wrw_mem((VP)(tbase+TOFF_TC_CCR), TC_CLKDIS);
    sil_wrw_mem((VP)(tbase+TOFF_TC_IDR), 0xFFFFFFFF);
    /*  ͤ򥻥å */
    sil_wrw_mem((VP)(tbase+TOFF_TC_CMR), TC_CLKS_MCK8);	/* 47,923,200Hz/8=5,990,400Hz */
    sil_wrw_mem((VP)(tbase+TOFF_TC_CMR), sil_rew_mem((VP)(tbase+TOFF_TC_CMR)) | TC_WAVESEL10);
    sil_wrw_mem((VP)(tbase+TOFF_TC_RC), 59900);			/* 10ms */
    /*  ߤζػ  */
	uart_disable_rcv(btcb);
#endif	/* ROI DEBUG */
	bt_disable_send(btcb);
#if 0	/* ROI DEBUG */
    /*  ȥ   */
    sil_wrw_mem((VP)(tbase+TOFF_TC_CCR), (TC_CLKEN|TC_SWTRG));
#endif	/* ROI DEBUG */
	return btcb;
}

/*
 *  BLUETOOTHǥХ
 */
int bluetooth_close_device(BTCB *btcb)
{
	if(btcb->open_flag){
#if 0	/* ROI DEBUG */
	    /* ߤ  */
		uart_disable_rcv(siopcb);
   		 /*  */
    	sil_wrw_mem((VP)(siopcb->siopinib->time_base+TOFF_TC_CCR), TC_CLKDIS);
    	sil_wrw_mem((VP)(siopcb->siopinib->time_base+TOFF_TC_IDR), 0xFFFFFFFF);
		sil_wrw_mem((VP)(siopcb->siopinib->uart_base+TOFF_US_CR), US_RSTRX|US_RSTTX|US_RXDIS|US_TXDIS);
#endif	/* ROI DEBUG */
		btcb->open_flag = FALSE;
	}
	return BTDEV_OK;
}

/*
 *  BLUETOOTHΥޥɼԤǡ֤
 */
UINT32
bluetooth_received_count(BTCB *btcb)
{
	int     bytes_ready;

	if(get_us1_rcvcnt2() == 0)
		bytes_ready = SIORBUFSIZE*2 - get_us1_rcvcnt1();
	else
		bytes_ready = SIORBUFSIZE - get_us1_rcvcnt1();
	return bytes_ready - btcb->rcv_idx;
}

/*
 *  BLUETOOTHѤΥޥѶѥåȤ֤
 */
INT32
bluetooth_get_packet(BTCB *btcb, BTPACKET **ppkt, INT32 *plen)
{
	INT32  no;

	if((no = bluetooth_search_packet(btcb, SND_EMPY)) >= 0){
		btcb->snd_stat[SND_EMPY] &= ~(1<<no);
		*ppkt = &btcb->snd_buf[no];
		*plen = SIORBUFSIZE;
		return BTDEV_OK;
	}
	else{
		*plen = 0;
		return BTDEV_NOMEM;
	}
}

/*
 *  BLUETOOTHΥޥѥåȤ׵᤹
 */
INT32
bluetooth_send(BTCB *btcb, BTPACKET *p)
{
	if(uart_putready(btcb)){
		btcb->snd_stat[SND_RDY] |= 1<<p->id;
		bt_enable_send(btcb);
	}
	return BTDEV_OK;
}

/*
 *  BLUETOOTHޥɤФ
 */
INT32
bluetooth_receive(BTCB *btcb, unsigned char * buf)
{
	int bytes_ready, total_bytes_ready;
	int cmd_len = 0;
	int i;
	unsigned char *buf_ptr, *tmp_ptr;

	buf_ptr = &(btcb->rcv_buf[btcb->rcv_no&1][0]);
	buf[0] = 0;
	buf[1] = 0;

	if (get_us1_rcvcnt2() == 0){
	  	bytes_ready = SIORBUFSIZE;
	  	total_bytes_ready = SIORBUFSIZE*2 - get_us1_rcvcnt1();
	}
	else{
		total_bytes_ready = bytes_ready = SIORBUFSIZE - get_us1_rcvcnt1();
	}
	/*
	 *  2ХȰʾμǡ
	 *  ޥɤμߤԤ
	 */
	if (total_bytes_ready > btcb->rcv_idx + 1) {
	  	cmd_len = (int) buf_ptr[btcb->rcv_idx];
  	
	  	// Data mode kludge - data cannot be more than 255 bytes
  	
		if (btcb->rcv_idx < (SIORBUFSIZE-1)){
	  		if (buf_ptr[btcb->rcv_idx+1] == 0) cmd_len++;
		}
		else{
			tmp_ptr = &(btcb->rcv_buf[(btcb->rcv_no+1)&1][0]);
			if (tmp_ptr[0] == 0) cmd_len++;
		}
		/*
		 *  ޥɤμߤԤ
		 */
		if (bytes_ready >= btcb->rcv_idx + cmd_len + 1) {
			for(i=0;i<cmd_len+1;i++) buf[i] = buf_ptr[btcb->rcv_idx++];
		}
		else if (total_bytes_ready >= btcb->rcv_idx + cmd_len + 1){
			for(i=0;i<cmd_len+1 && btcb->rcv_idx < 128;i++) buf[i] = buf_ptr[btcb->rcv_idx++];
			btcb->rcv_idx = 0;
			tmp_ptr = &(btcb->rcv_buf[(btcb->rcv_no+1)&1][0]);
			for(;i<cmd_len+1;i++) buf[i] = tmp_ptr[btcb->rcv_idx++];
			btcb->rcv_idx += SIORBUFSIZE;
		}
		else{	/* ޥɤƼƤʤ */
			return BTDEV_NOMEM;
		}
	}
	/*
	 *  ǥåSIORBUFSIZEۤ
	 *  ȥμХåեȼǥåꤹ
	 */
	if (btcb->rcv_idx >= SIORBUFSIZE && get_us1_rcvcnt2() == 0){
 		btcb->rcv_idx -= SIORBUFSIZE;
		set_us1_rcvptr2((unsigned int) buf_ptr);
		set_us1_rcvcnt2(SIORBUFSIZE);
		btcb->rcv_no++;
	}
	return cmd_len;
}

/*
 *  BLUETOOTHޥɤФ
 */
INT32
bluetooth_recvchar(BTCB *btcb)
{
	unsigned char *buf_ptr;
	int bytes_ready, total_bytes_ready;
	INT32 c = 0;

	buf_ptr = &(btcb->rcv_buf[btcb->rcv_no&1][0]);

	if (get_us1_rcvcnt2() == 0){
	  	bytes_ready = SIORBUFSIZE;
	  	total_bytes_ready = SIORBUFSIZE*2 - get_us1_rcvcnt1();
	}
	else{
		total_bytes_ready = bytes_ready = SIORBUFSIZE - get_us1_rcvcnt1();
	}
	/*
	 *  2ХȰʾμǡ
	 *  ޥɤμߤԤ
	 */
	if (total_bytes_ready > btcb->rcv_idx ) {
	  	c = (INT32) buf_ptr[btcb->rcv_idx++];
	}
	/*
	 *  ǥåSIORBUFSIZEۤ
	 *  ȥμХåեȼǥåꤹ
	 */
	if (btcb->rcv_idx >= SIORBUFSIZE && get_us1_rcvcnt2() == 0){
 		btcb->rcv_idx -= SIORBUFSIZE;
		set_us1_rcvptr2((unsigned int) buf_ptr);
		set_us1_rcvcnt2(SIORBUFSIZE);
		btcb->rcv_no++;
	}
	return c;
}

/*
 *  BLUETOOTHǥХΥꥻå׵
 *  ߥϥɥ餫¹Բǽ
 */
INT32
bluetooth_reset(BTCB *btcb)
{
	UINT8  *buf;
	INT32  cnt;

	/*
	 *  Ÿվ֤Ǥϼ¹Ԥʤ
	 */
	if((sil_rew_mem((VP)(TADR_PIO_BASE+TOFF_PIO_ODSR)) & BT_RST_PIN) == 0){
		return BTDEV_OK;
	}
	/*
	 *  ޥɥ⡼
	 */
	bluetooth_clear_arm7_cmd();
	/*
     *  BC4åפФ100ms֥ꥻå
	 */
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_CODR), BT_RST_PIN);
	buf = btcb->siobuffer;
	for(cnt = 0 ; cnt < 100 ; cnt++){
		bluetooth_receive(btcb, buf);
		sil_dly_nse(1000*1000);	/* 1msԤ */
	}
	sil_wrw_mem((VP)(TADR_PIO_BASE+TOFF_PIO_SODR), BT_RST_PIN);
	/*
	 * 5ô֤RESET INDICATIONԤԤ
	 */
	for(cnt = 0 ; cnt < 5000 ; cnt++){
		bluetooth_receive(btcb, buf);
		/*
		 *  RESET INDICATIONȥåγǧ
		 */
		if ((buf[0] == 3) && (buf[1] == MSG_RESET_INDICATION) &&
			(buf[2] == 0xff) && (buf[3] == 0xe9))
			break;
		sil_dly_nse(1000*1000);	/* 1msԤ */
	}
	/*
	 *  ޥɥ⡼ɺ
	 */
	bluetooth_clear_arm7_cmd();
	return BTDEV_OK;
}

/*
 *  SIOγߥӥ롼
 */
void
RxHwSerialInt(void)
{
	BTCB *btcb = &btcb_table[0];
	btcb->intflag = TRUE;
    if (uart_putready(btcb)) {
		bluetooth_tx_int(btcb);
    }
	btcb->intflag = FALSE;
}

